#include "fifocore.h"
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <signal.h>
#include <sys/signal.h>

static void *myfifo;


void cleanquit(int thesignal)
{
  if (thesignal!=SIGINT)
   {
    return;
  }
  fifoclose(myfifo);
  exit (1);
}
  


int main()
{
  int n;
  char mystring[50];
  struct sigaction mysignal;

  signal(SIGINT, cleanquit);

//  sigaction(SIGINT, &mysignal, NULL);

  myfifo=openfifo("thepipe",0,1);
  if (!myfifo)
  {
    printf("error opening\n");
    return 1;
  }

  for (n=0;n<10000;n++)
  {
    int rlen;
    snprintf(mystring,50,"%6d\n",n);
    if ((rlen=fifowrite(myfifo,mystring,strlen(mystring)))!=strlen(mystring))
    {
       printf("error writing %d %s\n",errno,strerror(errno));
       break;
    }
    else
       printf("%s\n",mystring);
  }

  if (fifoclose(myfifo))
  {
    printf("error closing\n");
    return 1;
  }
}
